diff -U 5 -N -r -w ../orig.HEAD/doc/src/sgml/datatype.sgml ./doc/src/sgml/datatype.sgml
--- ../orig.HEAD/doc/src/sgml/datatype.sgml	2013-08-19 20:22:06.000000000 -0400
+++ ./doc/src/sgml/datatype.sgml	2013-08-19 20:54:00.000000000 -0400
@@ -159,10 +159,22 @@
        <entry></entry>
        <entry>currency amount</entry>
       </row>
 
       <row>
+       <entry><type>national character varying [ (<replaceable>n</replaceable>) ]</type></entry>
+       <entry><type>nvarchar [ (<replaceable>n</replaceable>) ]</type></entry>
+       <entry>variable-length national character string</entry>
+      </row>
+
+      <row>
+       <entry><type>national character [ (<replaceable>n</replaceable>) ]</type></entry>
+       <entry><type>nchar [ (<replaceable>n</replaceable>) ]</type></entry>
+       <entry>fixed-length national character string</entry>
+      </row>
+
+      <row>
        <entry><type>numeric [ (<replaceable>p</replaceable>,
          <replaceable>s</replaceable>) ]</type></entry>
        <entry><type>decimal [ (<replaceable>p</replaceable>,
          <replaceable>s</replaceable>) ]</type></entry>
        <entry>exact numeric of selectable precision</entry>
@@ -4661,6 +4673,195 @@
     <type>internal</> argument.
    </para>
 
   </sect1>
 
+  <sect1 id="datatype-national-character">
+   <title>National Character Types</title>
+
+   <indexterm zone="datatype-national-character">
+    <primary>national character string</primary>
+    <secondary>data types</secondary>
+   </indexterm>
+
+   <indexterm>
+    <primary>string</primary>
+    <see>national character string</see>
+   </indexterm>
+
+   <indexterm zone="datatype-national-character">
+    <primary>national character</primary>
+   </indexterm>
+
+   <indexterm zone="datatype-national-character">
+    <primary>national character varying</primary>
+   </indexterm>
+
+   <indexterm zone="datatype-national-character">
+    <primary>nchar</primary>
+   </indexterm>
+
+   <indexterm zone="datatype-national-character">
+    <primary>nvarchar</primary>
+   </indexterm>
+
+    <table id="datatype-national-character-table">
+     <title>National Character Types</title>
+     <tgroup cols="2">
+      <thead>
+       <row>
+        <entry>Name</entry>
+        <entry>Description</entry>
+       </row>
+      </thead>
+      <tbody>
+       <row>
+        <entry><type>national character varying(<replaceable>n</>)</type>, <type>nvarchar(<replaceable>n</>)</type></entry>
+        <entry>variable-length with limit</entry>
+       </row>
+       <row>
+        <entry><type>national character(<replaceable>n</>)</type>, <type>nchar(<replaceable>n</>)</type></entry>
+        <entry>fixed-length, blank padded</entry>
+       </row>
+     </tbody>
+     </tgroup>
+    </table>
+
+   <para>
+    <xref linkend="datatype-national-character-table"> shows the
+    general-purpose national character types available in
+    <productname>PostgreSQL</productname>.
+   </para>
+
+   <para>
+    <acronym>SQL</acronym> defines two primary national character types:
+    <type>national character varying(<replaceable>n</>)</type> and
+    <type>national character(<replaceable>n</>)</type>, where <replaceable>n</>
+    is a positive integer.  Both of these types can store strings up to
+    <replaceable>n</> national characters (not bytes) in length.  An attempt to store a
+    longer string into a column of these types will result in an
+    error, unless the excess characters are all spaces, in which case
+    the string will be truncated to the maximum length. 
+    If the string to be stored is shorter than the declared
+    length, values of type <type>national character</type> will be space-padded;
+    values of type <type>national character varying</type> will simply store the
+    shorter
+    string.
+   </para>
+
+   <para>
+    If one explicitly casts a value to <type>national character
+    varying(<replaceable>n</>)</type> or
+    <type>national character(<replaceable>n</>)</type>, then an over-length
+    value will be truncated to <replaceable>n</> characters without
+    raising an error. (This too is required by the
+    <acronym>SQL</acronym> standard.)
+   </para>
+
+   <para>
+    The notations <type>nvarchar(<replaceable>n</>)</type> and
+    <type>nchar(<replaceable>n</>)</type> are aliases for <type>national character
+    varying(<replaceable>n</>)</type> and
+    <type>national character(<replaceable>n</>)</type>, respectively.
+    <type>national character</type> without length specifier is equivalent to
+    <type>national character(1)</type>. If <type>national character varying</type> is used
+    without length specifier, the type accepts strings of any size. The
+    latter is a <productname>PostgreSQL</> extension.
+   </para>
+
+   <para>
+    Values of type <type>national character</type> are physically padded
+    with spaces to the specified width <replaceable>n</>, and are
+    stored and displayed that way.  However, the padding spaces are
+    treated as semantically insignificant.  Trailing spaces are
+    disregarded when comparing two values of type <type>national character</type>,
+    and they will be removed when converting a <type>national character</type> value
+    to one of the other string types.  Note that trailing spaces
+    <emphasis>are</> semantically significant in
+    <type>national character varying</type> values, and
+    when using pattern matching, e.g. <literal>LIKE</>,
+    regular expressions.
+   </para>
+
+   <para>
+    The storage requirement for a short string (up to 126 bytes) is 1 byte
+    plus the actual string, which includes the space padding in the case of
+    <type>national character</type>.  Longer strings have 4 bytes of overhead instead
+    of 1.  Long strings are compressed by the system automatically, so
+    the physical requirement on disk might be less. Very long values are also
+    stored in background tables so that they do not interfere with rapid
+    access to shorter column values. In any case, the longest
+    possible character string that can be stored is about 1 GB. (The
+    maximum value that will be allowed for <replaceable>n</> in the data
+    type declaration is less than that. It wouldn't be useful to
+    change this because with multibyte character encodings the number of
+    characters and bytes can be quite different. If you desire to
+    store long strings with no specific upper limit, use
+    <type>text</type> or <type>national character varying</type> without a length
+    specifier, rather than making up an arbitrary length limit.)
+   </para>
+
+   <tip>
+    <para>
+     There is no performance difference among these two types,
+     apart from increased storage space when using the blank-padded
+     type, and a few extra CPU cycles to check the length when storing into
+     a length-constrained column.  While
+     <type>national character(<replaceable>n</>)</type> has performance
+     advantages in some other database systems, there is no such advantage in
+     <productname>PostgreSQL</productname>; in fact
+     <type>national character(<replaceable>n</>)</type> is usually the slowest of
+     the three because of its additional storage costs.  In most situations
+     <type>text</type> or <type>national character varying</type> should be used
+     instead.
+    </para>
+   </tip>
+
+   <para>
+    Refer to <xref linkend="sql-syntax-strings"> for information about
+    the syntax of string literals, and to <xref linkend="functions">
+    for information about available operators and functions. The
+    database character set determines the character set used to store
+    textual values. The <type>national character varying</type> or <type>national character</type> types are supported only when the database encoding is UTF-8; for more information on character set support,
+    refer to <xref linkend="multibyte">.
+   </para>
+
+   <example>
+    <title>Using the National Character Types</title>
+
+<programlisting>
+CREATE TABLE test1 (a national character(4));
+INSERT INTO test1 VALUES (N'ok');
+SELECT a, char_length(a) FROM test1; -- <co id="co.datatype-nchar">
+<computeroutput>
+  a   | char_length
+------+-------------
+ ok   |           2
+</computeroutput>
+
+CREATE TABLE test2 (b nvarchar(5));
+INSERT INTO test2 VALUES (N'ok');
+INSERT INTO test2 VALUES (N'good      ');
+INSERT INTO test2 VALUES (N'too long');
+<computeroutput>ERROR:  value too long for type national character varying(5)</computeroutput>
+INSERT INTO test2 VALUES ('too long'::nvarchar(5)); -- explicit truncation
+SELECT b, char_length(b) FROM test2;
+<computeroutput>
+   b   | char_length
+-------+-------------
+ ok    |           2
+ good  |           5
+ too l |           5
+</computeroutput>
+</programlisting>
+    <calloutlist>
+     <callout arearefs="co.datatype-nchar">
+      <para>
+       The <function>char_length</function> function is discussed in
+       <xref linkend="functions-string">.
+      </para>
+     </callout>
+    </calloutlist>
+   </example>
+
+  </sect1>
  </chapter>
diff -U 5 -N -r -w ../orig.HEAD/doc/src/sgml/ecpg.sgml ./doc/src/sgml/ecpg.sgml
--- ../orig.HEAD/doc/src/sgml/ecpg.sgml	2013-08-19 20:22:06.000000000 -0400
+++ ./doc/src/sgml/ecpg.sgml	2013-08-19 20:54:00.000000000 -0400
@@ -888,10 +888,20 @@
 
       <row>
        <entry><type>boolean</type></entry>
        <entry><type>bool</type><footnote><para>declared in <filename>ecpglib.h</filename> if not native</para></footnote></entry>
       </row>
+      
+      <row>
+       <entry><type>national character(<replaceable>n</>)</type>, <type>nvarchar(<replaceable>n</>)</type></entry>
+       <entry><type>NCHAR[<replaceable>n</>+1]</type>, <type>NVARCHAR[<replaceable>n</>+1]</type></entry>
+      </row>
+      
+      <row>
+       <entry><type>national character(<replaceable>n</>)</type>, <type>nvarchar(<replaceable>n</>)</type>, <type>character(<replaceable>n</>)</type>, <type>varchar(<replaceable>n</>)</type>, <type>text</type></entry>
+       <entry><type>UVARCHAR[<replaceable>2*n</>]</type></entry>
+      </row>
      </tbody>
     </tgroup>
    </table>
 
    <sect3 id="ecpg-char">
@@ -966,10 +976,197 @@
      also hold values of other SQL types, which will be stored in
      their string forms.
     </para>
    </sect3>
 
+   <sect3 id="ecpg-nchar">
+    <title>Handling National Character Strings</title>
+
+    <para>
+     To handle SQL national character string data types, such
+     as <type>nvarchar</type> and <type>nchar</type>, there are two
+     possible ways to declare the host variables.
+    </para>
+
+    <para>
+     One way is using <type>NCHAR[]</type>, an array
+     of <type>NCHAR</type>, internally which is mapped to an array of <type>char</type> which is the most common way to handle
+     character data in C.
+<programlisting>
+EXEC SQL BEGIN DECLARE SECTION;
+    NCHAR str[50];
+EXEC SQL END DECLARE SECTION;
+</programlisting>
+     Note that you have to take care of the length yourself.  If you
+     use this host variable as the target variable of a query which
+     returns a string with more than 49 characters, a buffer overflow
+     occurs.
+    </para>
+
+    <para>
+     The other way is using the <type>NVARCHAR</type> type, which is a
+     special type provided by ECPG.  The definition on an array of
+     type <type>NVARCHAR</type> is converted into a
+     named <type>struct</> for every variable. A declaration like:
+<programlisting>
+NVARCHAR var[180];
+</programlisting>
+     is converted into:
+<programlisting>
+struct varchar_var { int len; char arr[180]; } var;
+</programlisting>
+     The member <structfield>arr</structfield> hosts the string
+     including a terminating zero byte.  Thus, to store a string in
+     a <type>NVARCHAR</type> host variable, the host variable has to be
+     declared with the length including the zero byte terminator.  The
+     member <structfield>len</structfield> holds the length of the
+     string stored in the <structfield>arr</structfield> without the
+     terminating zero byte.  When a host variable is used as input for
+     a query, if <literal>strlen(arr)</literal>
+     and <structfield>len</structfield> are different, the shorter one
+     is used.
+    </para>
+
+    <para>
+     Two or more <type>NVARCHAR</type> host variables cannot be defined
+     in single line statement.  The following code will confuse
+     the <command>ecpg</command> preprocessor:
+<programlisting>
+NVARCHAR v1[128], v2[128];   /* WRONG */
+</programlisting>
+     Two variables should be defined in separate statements like this:
+<programlisting>
+NVARCHAR v1[128];
+NVARCHAR v2[128];
+</programlisting>
+    </para>
+
+    <para>
+     <type>NVARCHAR</type> and <type>NCHAR</type> can be written in upper or lower case, but
+     not in mixed case.
+    </para>
+
+    <para>
+     <type>NCHAR</type> and <type>NVARCHAR</type> host variables can
+     also hold values of other SQL types, which will be stored in
+     their string forms. NVARCHAR type is pretty similar to VARCHAR type 
+     and added mainly for SQL standard compatibility.
+    </para>
+   </sect3>
+
+   <sect3 id="ecpg-uvarchar">
+    <title>Handling Strings with UVARCHAR type</title>
+
+    <para>
+     ECPG contains a special type <type>UVARCHAR</type> for defining host variables to store 
+     character string and national character string values from respective SQL types. 
+
+     This type is preprocessed into a structure with length and buffer fields.
+
+     <programlisting>
+      struct uvarchar_var { int len; char arr[180]; } uvc;
+     </programlisting>
+
+    The data stored by <type>UVARCHAR</type> type structure is always in UTF-16 encoding. There is an implicit conversion from UTF-8 to UTF-16 when UVARCHAR type is created.
+    </para>
+    
+    <para>
+     The sample usage of UVARCHAR to handle string data
+     
+     <programlisting>
+      #include &lt;stdio.h>
+ 
+      EXEC SQL INCLUDE sqlca;
+      EXEC SQL WHENEVER SQLERROR   SQLPRINT;
+      
+      int main( int argc, char * argv[] )
+      {
+          EXEC SQL BEGIN DECLARE SECTION;
+          UVARCHAR uv[100];
+          EXEC SQL END DECLARE SECTION;
+      
+          EXEC SQL CONNECT TO postgres;
+          EXEC SQL CREATE TABLE test (a nvarchar);
+          EXEC SQL INSERT INTO test (a) values ('ok'),
+      ...
+          EXEC SQL SELECT a INTO :uv FROM test;
+          printf("value=%s length=%d\n", uv.arr, uv.len);
+      ...
+      ...
+      }
+     </programlisting>
+
+     The member <structfield>arr</structfield> hosts the string
+     without a terminating zero byte.  As the default encoding for 
+     <type>UVARCHAR</type> is UTF-16, to store a string in a 
+     <type>UVARCHAR</type> host variable, the host variable has to be
+     declared with the minimum length of 2*n. The member <structfield>len</structfield> 
+     holds the length of the string stored in the <structfield>arr</structfield>.
+     When a host variable is used as input for a query, 
+     if <literal>strlen(arr)</literal> and <structfield>len</structfield> 
+     are different, the shorter one is used.
+
+    </para>
+
+   </sect3>
+
+   <sect3 id="ecpg-datatype-comparison">
+    <title>Comparison between VARCHAR, NVARCHAR and UVARCHAR Types</title>
+    <para>
+    The host data types used for handling string values, differ in few aspects like memory usage, encoding, performance etc.
+    <xref linkend="ecpg-datatype-comaprison-table"> shows the comparison of 
+    host data types.
+ 
+    </para>
+    <table id="ecpg-datatype-comaprison-table">
+     <title>Comparison between VARCHAR, NVARCHAR and UVARCHAR Types</title>
+
+     <tgroup cols="4">
+      <thead>
+       <row>
+        <entry></entry>
+        <entry>VARCHAR</entry>
+        <entry>NVARCHAR</entry>
+        <entry>UVARCHAR</entry>
+       </row>
+      </thead>
+
+      <tbody>
+       <row>
+        <entry><type>Maximum Size for 'n' characters</type></entry>
+        <entry><type>4*n + 1</type></entry>
+        <entry><type>4*n + 1</type></entry>
+        <entry><type>4*n</type></entry>
+       </row>
+       <row>
+        <entry><type>Minimum Size for 'n' characters</type></entry>
+        <entry><type>n + 1</type></entry>
+        <entry><type>n + 1</type></entry>
+        <entry><type>2*n</type></entry>
+       </row>
+       <row>
+        <entry><type>Encoding Used</type></entry>
+        <entry><type>client encoding</type></entry>
+        <entry><type>client encoding</type></entry>
+        <entry><type>UTF-16</type></entry>
+       </row>
+       <row>
+        <entry><type>Zero Terminated</type></entry>
+        <entry><type>Yes</type></entry>
+        <entry><type>Yes</type></entry>
+        <entry><type>No</type></entry>
+       </row>
+
+      </tbody>
+     </tgroup>
+    </table>
+
+	<para>
+     Please note that the data conversion from UTF-8 encoding to UTF-16 encoding will incur a negligible performance overhead in case of UVARCHAR Type.
+    </para>
+   </sect3>
+
    <sect3 id="ecpg-special-types">
     <title>Accessing Special Data Types</title>
 
     <para>
      ECPG contains some special types that help you to interact easily
diff -U 5 -N -r -w ../orig.HEAD/doc/src/sgml/syntax.sgml ./doc/src/sgml/syntax.sgml
--- ../orig.HEAD/doc/src/sgml/syntax.sgml	2013-08-19 20:22:06.000000000 -0400
+++ ./doc/src/sgml/syntax.sgml	2013-08-19 20:54:00.000000000 -0400
@@ -551,10 +551,37 @@
      To include the escape character in the string literally, write it
      twice.
     </para>
    </sect3>
 
+   <sect3 id="sql-syntax-strings-N">
+    <title>String Constants with prefix N</title>
+
+    <indexterm  zone="sql-syntax-strings-N">
+     <primary>Prefix N</primary>
+     <secondary>in string constants</secondary>
+    </indexterm>
+
+    <para>
+    The standard syntax for specifying national character type string constants 
+    is to add a prefix 'N' to the string constant. This string constant syntax
+    is supported only when the database encoding is UTF-8.
+    
+    The following trivial example shows how to pass a national character type 
+    string constant with prefix 'N'
+    
+        <programlisting>
+			INSERT INTO test VALUES (N'ok');
+		</programlisting>
+    
+    </para>
+    <para>
+    Please note that this syntax is optional and national character type string constants can also be specified bounded by single quotes (<literal>'</literal>), for example
+     <literal>'ok'</literal>.
+    </para>
+   </sect3>
+
    <sect3 id="sql-syntax-dollar-quoting">
     <title>Dollar-quoted String Constants</title>
 
      <indexterm>
       <primary>dollar quoting</primary>
diff -U 5 -N -r -w ../orig.HEAD/src/backend/catalog/information_schema.sql ./src/backend/catalog/information_schema.sql
--- ../orig.HEAD/src/backend/catalog/information_schema.sql	2013-08-19 20:22:07.000000000 -0400
+++ ./src/backend/catalog/information_schema.sql	2013-08-19 20:54:00.000000000 -0400
@@ -77,11 +77,11 @@
     RETURNS NULL ON NULL INPUT
     AS
 $$SELECT
   CASE WHEN $2 = -1 /* default typmod */
        THEN null
-       WHEN $1 IN (1042, 1043) /* char, varchar */
+       WHEN $1 IN (1042, 1043, 5001, 6001) /* char, varchar, nchar, nvarchar */
        THEN $2 - 4
        WHEN $1 IN (1560, 1562) /* bit, varbit */
        THEN $2
        ELSE null
   END$$;
@@ -90,11 +90,11 @@
     LANGUAGE sql
     IMMUTABLE
     RETURNS NULL ON NULL INPUT
     AS
 $$SELECT
-  CASE WHEN $1 IN (25, 1042, 1043) /* text, char, varchar */
+  CASE WHEN $1 IN (25, 1042, 1043, 5001, 6001) /* text, char, varchar, nchar, nvarchar */
        THEN CASE WHEN $2 = -1 /* default typmod */
                  THEN CAST(2^30 AS integer)
                  ELSE information_schema._pg_char_max_length($1, $2) *
                       pg_catalog.pg_encoding_max_length((SELECT encoding FROM pg_catalog.pg_database WHERE datname = pg_catalog.current_database()))
             END
diff -U 5 -N -r -w ../orig.HEAD/src/backend/parser/gram.y ./src/backend/parser/gram.y
--- ../orig.HEAD/src/backend/parser/gram.y	2013-08-19 20:22:08.000000000 -0400
+++ ./src/backend/parser/gram.y	2013-08-19 21:42:23.000000000 -0400
@@ -439,13 +439,15 @@
 
 %type <typnam>	Typename SimpleTypename ConstTypename
 				GenericType Numeric opt_float
 				Character ConstCharacter
 				CharacterWithLength CharacterWithoutLength
+				NCharacterWithLength NCharacterWithoutLength
 				ConstDatetime ConstInterval
 				Bit ConstBit BitWithLength BitWithoutLength
 %type <str>		character
+%type <str>             ncharacter
 %type <str>		extract_arg
 %type <str>		opt_charset
 %type <boolean> opt_varying opt_timezone opt_no_inherit
 
 %type <ival>	Iconst SignedIconst
@@ -562,10 +564,11 @@
 	MAPPING MATCH MATERIALIZED MAXVALUE MINUTE_P MINVALUE MODE MONTH_P MOVE
 
 	NAME_P NAMES NATIONAL NATURAL NCHAR NEXT NO NONE
 	NOT NOTHING NOTIFY NOTNULL NOWAIT NULL_P NULLIF
 	NULLS_P NUMERIC
+	NVARCHAR
 
 	OBJECT_P OF OFF OFFSET OIDS ON ONLY OPERATOR OPTION OPTIONS OR
 	ORDER ORDINALITY OUT_P OUTER_P OVER OVERLAPS OVERLAY OWNED OWNER
 
 	PARSER PARTIAL PARTITION PASSING PASSWORD PLACING PLANS POSITION
@@ -10277,13 +10280,22 @@
 				}
 			| CharacterWithoutLength
 				{
 					$$ = $1;
 				}
+			| NCharacterWithLength
+				{
+					$$ = $1;
+				}
+			| NCharacterWithoutLength
+				{
+					$$ = $1;
+				}
 		;
 
-ConstCharacter:  CharacterWithLength
+ConstCharacter:
+			CharacterWithLength
 				{
 					$$ = $1;
 				}
 			| CharacterWithoutLength
 				{
@@ -10294,13 +10306,79 @@
 					 * was not specified.
 					 */
 					$$ = $1;
 					$$->typmods = NIL;
 				}
+			| NCharacterWithLength
+				{
+					$$ = $1;
+				}
+			| NCharacterWithoutLength
+				{
+					/* Length was not specified so allow to be unrestricted.
+					* This handles problems with fixed-length (bpchar) strings
+					* which in column definitions must default to a length
+					* of one, but should not be constrained if the length
+					* was not specified.
+					*/
+					$$ = $1;
+					$$->typmods = NIL;
+				}
 		;
 
-CharacterWithLength:  character '(' Iconst ')' opt_charset
+NCharacterWithLength:
+			NATIONAL ncharacter '(' Iconst ')' opt_charset
+				{
+					if (($6 != NULL) && (strcmp($6, "sql_text") != 0))
+				{
+						char *type;
+
+						type = palloc(strlen($2) + 1 + strlen($2) + 1);
+						strcpy(type, $2);
+						strcat(type, "_");
+						strcat(type, $6);
+						$1 = type;
+					}
+					$$ = SystemTypeName($2);
+					$$->typmods = list_make1(makeIntConst($4, @4));
+					$$->location = @1;
+				}
+		;
+
+NCharacterWithoutLength:
+			NATIONAL ncharacter opt_charset
+				{
+					if (($3 != NULL) && (strcmp($3, "sql_text") != 0))
+					{
+						char *type;
+
+						type = palloc(strlen($2) + 1 + strlen($3) + 1);
+						strcpy(type, $2);
+						strcat(type, "_");
+						strcat(type, $3);
+						$2 = type;
+					}
+					$$ = SystemTypeName($2);
+					/* nchar defaults to char(1), varchar to no limit */
+					if (strcmp($2, "nbpchar") == 0)
+						$$->typmods = list_make1(makeIntConst(1, -1));
+
+					$$->location = @1;
+				}
+		;
+
+ncharacter:
+			CHARACTER opt_varying
+				{ $$ = $2 ? "nvarchar": "nbpchar"; }
+			| CHAR_P opt_varying
+				{ $$ = $2 ? "nvarchar": "nbpchar"; }
+			| VARCHAR
+				{ $$ = "nvarchar"; }
+		;
+
+CharacterWithLength:
+			  character '(' Iconst ')' opt_charset
 				{
 					if (($5 != NULL) && (strcmp($5, "sql_text") != 0))
 					{
 						char *type;
 
@@ -10315,11 +10393,12 @@
 					$$->typmods = list_make1(makeIntConst($3, @3));
 					$$->location = @1;
 				}
 		;
 
-CharacterWithoutLength:	 character opt_charset
+CharacterWithoutLength:
+			 character opt_charset
 				{
 					if (($2 != NULL) && (strcmp($2, "sql_text") != 0))
 					{
 						char *type;
 
@@ -10330,30 +10409,29 @@
 						$1 = type;
 					}
 
 					$$ = SystemTypeName($1);
 
-					/* char defaults to char(1), varchar to no limit */
-					if (strcmp($1, "bpchar") == 0)
+					/* [n]char defaults to [national ]char(1), varchar to no limit */
+					if ((strcmp($1, "bpchar") == 0) || (strcmp($1, "nbpchar") == 0))
 						$$->typmods = list_make1(makeIntConst(1, -1));
 
 					$$->location = @1;
 				}
 		;
 
-character:	CHARACTER opt_varying
+character:
+			CHARACTER opt_varying
 										{ $$ = $2 ? "varchar": "bpchar"; }
 			| CHAR_P opt_varying
 										{ $$ = $2 ? "varchar": "bpchar"; }
 			| VARCHAR
 										{ $$ = "varchar"; }
-			| NATIONAL CHARACTER opt_varying
-										{ $$ = $3 ? "varchar": "bpchar"; }
-			| NATIONAL CHAR_P opt_varying
-										{ $$ = $3 ? "varchar": "bpchar"; }
 			| NCHAR opt_varying
-										{ $$ = $2 ? "varchar": "bpchar"; }
+				{ $$ = $2 ? "nvarchar": "nbpchar"; }
+			| NVARCHAR
+				{ $$ = "nvarchar"; }
 		;
 
 opt_varying:
 			VARYING									{ $$ = TRUE; }
 			| /*EMPTY*/								{ $$ = FALSE; }
@@ -12739,10 +12817,11 @@
 			| NATIONAL
 			| NCHAR
 			| NONE
 			| NULLIF
 			| NUMERIC
+			| NVARCHAR
 			| OUT_P
 			| OVERLAY
 			| POSITION
 			| PRECISION
 			| REAL
diff -U 5 -N -r -w ../orig.HEAD/src/backend/parser/scan.l ./src/backend/parser/scan.l
--- ../orig.HEAD/src/backend/parser/scan.l	2013-08-19 20:22:08.000000000 -0400
+++ ./src/backend/parser/scan.l	2013-08-19 22:27:02.000000000 -0400
@@ -480,11 +480,11 @@
 					const ScanKeyword *keyword;
 
 					SET_YYLLOC();
 					yyless(1);				/* eat only 'n' this time */
 
-					keyword = ScanKeywordLookup("nchar",
+					keyword = ScanKeywordLookup("nvarchar",
 												yyextra->keywords,
 												yyextra->num_keywords);
 					if (keyword != NULL)
 					{
 						yylval->keyword = keyword->name;
diff -U 5 -N -r -w ../orig.HEAD/src/backend/utils/adt/format_type.c ./src/backend/utils/adt/format_type.c
--- ../orig.HEAD/src/backend/utils/adt/format_type.c	2013-08-19 20:22:09.000000000 -0400
+++ ./src/backend/utils/adt/format_type.c	2013-08-19 20:54:00.000000000 -0400
@@ -216,10 +216,25 @@
 			}
 			else
 				buf = pstrdup("character");
 			break;
 
+		case NBPCHAROID:
+			if (with_typemod)
+				buf = printTypmod("national character", typemod, typeform->typmodout);
+			else if (typemod_given)
+			{
+				/*
+				 * bpchar with typmod -1 is not the same as CHARACTER, which
+				 * means CHARACTER(1) per SQL spec.  Report it as bpchar so
+				 * that parser will not assign a bogus typmod.
+				 */
+			}
+			else
+				buf = pstrdup("national character");
+			break;
+
 		case FLOAT4OID:
 			buf = pstrdup("real");
 			break;
 
 		case FLOAT8OID:
@@ -291,10 +306,17 @@
 			if (with_typemod)
 				buf = printTypmod("character varying", typemod, typeform->typmodout);
 			else
 				buf = pstrdup("character varying");
 			break;
+
+		case NVARCHAROID:
+			if (with_typemod)
+				buf = printTypmod("national character varying", typemod, typeform->typmodout);
+			else
+				buf = pstrdup("national character varying");
+			break;
 	}
 
 	if (buf == NULL)
 	{
 		/*
@@ -381,11 +403,13 @@
 		return -1;
 
 	switch (type_oid)
 	{
 		case BPCHAROID:
+		case NBPCHAROID:
 		case VARCHAROID:
+		case NVARCHAROID:
 			/* typemod includes varlena header */
 
 			/* typemod is in characters not bytes */
 			return (typemod - VARHDRSZ) *
 				pg_encoding_max_length(GetDatabaseEncoding())
diff -U 5 -N -r -w ../orig.HEAD/src/backend/utils/adt/Makefile ./src/backend/utils/adt/Makefile
--- ../orig.HEAD/src/backend/utils/adt/Makefile	2013-08-19 20:22:09.000000000 -0400
+++ ./src/backend/utils/adt/Makefile	2013-08-20 04:53:45.000000000 -0400
@@ -18,11 +18,11 @@
 OBJS = acl.o arrayfuncs.o array_selfuncs.o array_typanalyze.o \
 	array_userfuncs.o arrayutils.o bool.o \
 	cash.o char.o date.o datetime.o datum.o domains.o \
 	enum.o float.o format_type.o \
 	geo_ops.o geo_selfuncs.o int.o int8.o json.o jsonfuncs.o like.o \
-	lockfuncs.o misc.o nabstime.o name.o numeric.o numutils.o \
+	lockfuncs.o misc.o nabstime.o name.o numeric.o numutils.o nvarchar.o \
 	oid.o oracle_compat.o pseudotypes.o rangetypes.o rangetypes_gist.o \
 	rowtypes.o regexp.o regproc.o ruleutils.o selfuncs.o \
 	tid.o timestamp.o varbit.o varchar.o varlena.o version.o xid.o \
 	network.o mac.o inet_cidr_ntop.o inet_net_pton.o \
 	ri_triggers.o pg_lzcompress.o pg_locale.o formatting.o \
